\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{mtt}[2011/04/22 MTT article]
%
%       
% 
%  :
%   utf8, cp1251, koi8
%        .    cp1251
%   russian, ukrainian, english
%         ,   russian.
%       ,     ,  
%        ru, uk, en.
%   draft
%         .   (B5) 
%           A4,   
%          .
%   a4cam
%          ( )   A4
%   a4mag
%            A4
%   a4paper
%        A4  B5,     (<=38)
%
%    ( \documentclass   \begin{document})
%   \title{ }
%   \title[. ]{ }
%           ". "  
%       .
%   \author{()}
%   \author[.]{()}
%       .
%   \address{      }
%       ,    
%   \email{author@iamm.ac.donetsk.ua}
%   \udk{}   
%   \thanks{    ...}
%
%     ( \begin{document}  \end{document})
%   \maketitle
%        ,   
%           
%   \makeaddressline
%        , email     
%          ,  \end{thebibliography},  
%         /
%   \section*{}
%   \section{ }
%      
%   \begin{theorem}...\end{theorem}
%   ;   lemma, remark, proposition,   proof
%
%        (  \maketitle):
%   \begin{abstract}[ru]
%       
%       \keywords{ }
%   \end{abstract}
%        (   ,  
%      \makeaddressline):
%   \begin{abstract}[en]
%       \author{  }
%       \title{   }
%         
%       \keywords{   }
%   \end{abstract}
%
%      :
%   \cite{1,2}
%          [2-5],   
%       \cite{2,3,4,5}
%    :
%   \begin{thebibliography}{0}
%       \bib[1]{.. } . --- :,   
%       \bib*[2]  //  . .. 
%   \end{thebibliography}
%        []  ,   .
%            \bibitem{}
%        \item ( )
%
\def\mtt@encoding{cp1251}
\def\mtt@language{russian}
\def\@udk{}
\def\@received{}
\def\@email{}
\def\@address{}

\def\mtt@bfivemode{b5mode}
\def\mtt@afourcam{a4cam}
\def\mtt@afourmag{a4mag}
\def\mtt@afourcut{a4cut}
\def\mtt@afourpaper{a4paper}
\let\mtt@pagemode=\mtt@bfivemode

\DeclareOption{utf8}{\def\mtt@encoding{utf8}}
\DeclareOption{koi8}{\def\mtt@encoding{koi8u}}
\DeclareOption{russian}{\def\mtt@language{russian}}
\DeclareOption{ru}{\def\mtt@language{ru}}
\DeclareOption{ukrainian}{\def\mtt@language{ukrainian}}
\DeclareOption{uk}{\def\mtt@language{ukrainian}}
\DeclareOption{english}{\def\mtt@language{english}}
\DeclareOption{en}{\def\mtt@language{english}}
\DeclareOption{showframe}{\PassOptionsToPackage{\CurrentOption}{geometry}}
\DeclareOption{verbose}{\PassOptionsToPackage{verbose}{geometry}}
\DeclareOption{showgeom}{\PassOptionsToPackage{verbose}{geometry}}
\DeclareOption{showgeometry}{\PassOptionsToPackage{verbose}{geometry}}
\DeclareOption{draft}{
    \PassOptionsToClass{draft}{article}
    \PassOptionsToPackage{graphicx}{final}
    \def\mtt@draft{true}
    \let\mtt@pagemode=\mtt@afourcam
    \def\mtt@pageframe{true}
}
\DeclareOption{a4cam}{\let\mtt@pagemode=\mtt@afourcam}
\DeclareOption{a4mag}{\let\mtt@pagemode=\mtt@afourmag}
\DeclareOption{a4cut}{\let\mtt@pagemode=\mtt@afourcut}
\DeclareOption{a4paper}{\let\mtt@pagemode=\mtt@afourpaper}
\DeclareOption{oldstyle}{\def\mtt@oldstyle{true}}
\DeclareOption*{\PassOptionsToClass{\CurrentOption}{article}}
\PassOptionsToPackage{\mtt@language}{babel}
\ProcessOptions\relax

\LoadClass[11pt,twoside]{article}
\RequirePackage[\mtt@encoding]{inputenc}
\RequirePackage[english,ukrainian,russian]{babel}
\RequirePackage[T2A]{fontenc}   %   \MakeUppercase     !
\RequirePackage{amsthm}
\RequirePackage{amsmath}
\RequirePackage{amssymb}
\RequirePackage[dvips,final]{graphicx}
\RequirePackage[dvips]{color}
\RequirePackage{ifthen}
\RequirePackage{bm}
\RequirePackage{keyval}
\RequirePackage{cite}
\RequirePackage[margin=20mm,
        font={it,footnotesize},labelfont={it,footnotesize},
        labelsep=period,justification=centering]{caption}
\PassOptionsToPackage{dvips,twoside,nomarginpar}{geometry}

%  
\ifx\mtt@pagemode\mtt@afourcam
    % B5   176x250; A4 - 210x297
    %   (210-176)/2 x (297-250)/2 = 17x23.5
    \typeout{MTT: A4cam mode}
    \PassOptionsToPackage{a4paper,layout=b5paper,layoutoffset={17mm,23.5mm}}{geometry}
\else\ifx\mtt@pagemode\mtt@afourmag
    \typeout{MTT: A4mag mode}
    \PassOptionsToPackage{b5paper,mag=1188}{geometry}
\else\ifx\mtt@pagemode\mtt@afourcut
    \typeout{MTT: A4mag mode}
    \PassOptionsToPackage{a4paper,layout=b5paper,layoutoffset={17mm,23.5mm},showcrop}{geometry}
\else\ifx\mtt@pagemode\mtt@afourpaper
    \typeout{MTT: A4 native mode}
    \PassOptionsToPackage{a4paper}{geometry}
\else
    \typeout{MTT: B5 native (default) mode}
    \PassOptionsToPackage{b5paper}{geometry}
\fi\fi\fi\fi
\RequirePackage[inner=25mm,outer=16mm,top=26.5mm,bottom=27.5mm,headsep=27pt]{geometry}

%   
\def\baselinestretch{0.9}
\tolerance=2000

%    . 
%      cp1251/utf8,      \cyr*
\def\mtt@english@keywords{Keywords}
\def\mtt@russian@keywords{\CYRK\cyrl\cyryu\cyrch\cyre\cyrv\cyrery\cyre\ \cyrs\cyrl\cyro\cyrv\cyra}
\def\mtt@ukrainian@keywords{\CYRK\cyrl\cyryu\cyrch\cyro\cyrv\cyrii\ \cyrs\cyrl\cyro\cyrv\cyra}

%     abstract
\def\mtt@@ru{russian}
\def\mtt@@en{english}
\def\mtt@@uk{ukrainian}
\def\l@angname#1{\ifx\csname mtt@@#1\endcsname\@empty #1\else\csname mtt@@#1\endcsname\fi}

% .  abstract  quotation  article
\renewenvironment{abstract}[1][ru]{
    \parindent=0pt
    \selectfont\setlength{\baselineskip}{8pt}\selectfont
    \def\mtt@abslang{\l@angname{#1}}
    \def\mtt@keywords{\csname mtt@\mtt@abslang @keywords\endcsname}
    \def\keywords##1{\item\footnotesize{\bfseries\mtt@keywords:} \slshape##1}
    \def\title##1{{\small\bfseries ##1}\item}
    \def\author##1{{\small\bfseries ##1}\item}
    \begin{otherlanguage*}{\mtt@abslang}
    \footnotesize
    \list{}{\listparindent  0pt
        \topsep     6mm
        \itemindent 0pt
        \itemsep    4pt plus 4pt minus 2pt
        \rightmargin    0pt
        \leftmargin 0pt
        \parsep        \z@ \@plus\p@}%
    \item\relax\footnotesize
}{\end{otherlanguage*}\endlist}

%   ..
\newtheoremstyle{theorem}{1mm}{1mm}{}{}{\hskip\parindent\bfseries}{.}{.5em}{%
	\thmname{#1}\thmnumber{\@ifnotempty{#1}{ }\@upn{#2}}\thmnote{{\the\thm@notefont #3}}%
}
\theoremstyle{theorem}
\def\mtt@english@theorem{Theorem}

\def\mtt@russian@theorem{\CYRT\cyre\cyro\cyrr\cyre\cyrm\cyra}
\def\mtt@ukrainian@theorem{\CYRT\cyre\cyro\cyrr\cyre\cyrm\cyra}
\newtheorem{theorem}{\csname mtt@\mtt@language @theorem\endcsname}

\def\mtt@english@lemma{Lemma}
\def\mtt@russian@lemma{\CYRL\cyre\cyrm\cyrm\cyra}
\def\mtt@ukrainian@lemma{\CYRL\cyre\cyrm\cyra}
\newtheorem{lemma}{\csname mtt@\mtt@language @lemma\endcsname}

\def\mtt@english@remark{Remark}
\def\mtt@russian@remark{\CYRZ\cyra\cyrm\cyre\cyrch\cyra\cyrn\cyri\cyre}
\newtheorem{remark}{\csname mtt@\mtt@language @remark\endcsname}

\def\mtt@english@proposition{Proposition}
\def\mtt@russian@proposition{\CYRP\cyrr\cyre\cyrd\cyrl\cyro\cyrzh\cyre\cyrn\cyri\cyre}
\newtheorem{proposition}{\csname mtt@\mtt@language @proposition\endcsname}

\def\mtt@english@statement{Statement}
\def\mtt@russian@statement{\CYRU\cyrt\cyrv\cyre\cyrr\cyrzh\cyrd\cyre\cyrn\cyri\cyre}
\def\mtt@ukrainian@statement{\CYRT\cyrv\cyre\cyrr\cyrd\cyrzh\cyre\cyrn\cyrn\cyrya}
\newtheorem{statement}{\csname mtt@\mtt@language @statement\endcsname}

\def\mtt@english@definition{Definition}
\def\mtt@russian@definition{\CYRO\cyrp\cyrr\cyre\cyrd\cyre\cyrl\cyre\cyrn\cyri\cyre}
\def\mtt@ukrainian@statement{\CYRV\cyri\cyrz\cyrn\cyra\cyrch\cyre\cyrn\cyrn\cyrya}
\newtheorem{definition}{\csname mtt@\mtt@language @definition\endcsname}

\def\mtt@english@proof{P\,r\,o\,o\,f}
\def\mtt@russian@proof{\CYRD\,\cyro\,\cyrk\,\cyra\,\cyrz\,\cyra\,\cyrt\,\cyre\,\cyrl\,\cyrsftsn\,\cyrs\,\cyrt\,\cyrv\,\cyro}
\def\proofname{\csname mtt@\mtt@language @proof\endcsname}
%     (. amsthm.sty)
\renewenvironment{proof}[1][\proofname]{\par
  \pushQED{\qed}%
  {\small\scshape #1.}
}{%
  \popQED\@endpefalse
  \vskip 1mm plus 2mm minus 1mm
}

% 
\def\mtt@ISSN{ISSN 0321-1975}
\def\mtt@MTT{\CYRM\cyre\cyrh\cyra\cyrn\cyri\cyrk\cyra\ \cyrt\cyrv\cyre\cyrr\cyrd\cyro\cyrg\cyro\ \cyrt\cyre\cyrl\cyra}
\def\mtt@PREPRINT{\CYRP\cyrr\cyre\cyrp\cyrr\cyri\cyrn\cyrt}
\def\mtt@NUM{\CYRV\cyrery\cyrp}
\def\mtt@UDK{\CYRU\CYRD\CYRK}
\def\mtt@RECV{\CYRP\cyro\cyrl\cyru\cyrch\cyre\cyrn\cyro}
\def\mtt@headtitle{\mtt@ISSN. \mtt@MTT. 
    \@ifundefined{mtt@number}{
        \typeout{MTT: preprint header}
        {\mdseries\mtt@PREPRINT.}
    }{
        \typeout{MTT: complete header}
        \@ifundefined{mtt@year}{\relax}{\mtt@year. }
        \mtt@NUM. \mtt@number
    }
}
\def\headrulewidth{0.4pt}
\def\headwidth{\textwidth}
\def\headrule#1{{\vskip0.6mm\hrule\@height#1\@width\headwidth \vskip-\headrulewidth\vskip-0.6mm}}
\def\mtt@head#1{\hbox to \headwidth{\vbox{#1}}}
\def\mtt@headstrut{\raisebox{-2pt}{\rule{0pt}{10pt}}}
\def\ps@headings{
    \def\@oddfoot{\hfill\thepage}
    \def\@evenfoot{\thepage\hfill}
    \def\@evenhead{\mtt@head{\mtt@headstrut\hfill{\footnotesize\slshape\mtt@author}\hfill\mtt@headstrut\headrule{0pt}}}
    \def\@oddhead{\mtt@head{\mtt@headstrut\hfill{\footnotesize\slshape\mtt@title}\hfill\mtt@headstrut\headrule{0pt}}}
    \let\@mkboth\markboth
}
\def\ps@frontpage{
    \def\@oddfoot{\hfill\thepage}
    \def\@evenfoot{\thepage\hfill}
    \def\@oddhead{\mtt@head{\hfill\footnotesize\bfseries\mtt@headtitle\headrule{0.4pt}}}
    \let\@evenhead=\@oddhead
    \let\@mkboth\markboth
}
\pagestyle{headings}

% /,    
%   mtt@setkey{K}{foo} -> @K=foo, mtt@K=foo
%   mtt@setkey{K}[bar]{foo} -> @K=foo, mtt@K=bar
%   @K   , mtt@K   
\def\mtt@setkey#1{\@ifnextchar[{\mtt@setkeyalt{#1}}{\mtt@setkeyone{#1}}}
\def\mtt@setkeyone#1#2{\expandafter\def\csname @#1\endcsname{#2}\expandafter\def\csname mtt@#1\endcsname{#2}}
\def\mtt@setkeyalt#1[#2]#3{\expandafter\def\csname @#1\endcsname{#3}\expandafter\def\csname mtt@#1\endcsname{#2}}
\def\author{\mtt@setkey{author}}
\def\title{\mtt@setkey{title}}
%        
\def\email#1{\def\@email{#1}}
\def\address#1{\def\@address{#1}}
\def\received#1{\def\@received{#1}}
\def\udk#1{\def\@udk{#1}}
\def\thanks#1{\def\@thanks{#1}}

%  \mtt    keyval
\define@key{mtt}{y}{\def\mtt@year{#1}}
\define@key{mtt}{year}{\def\mtt@year{#1}}
\define@key{mtt}{n}{\def\mtt@number{#1}}
\define@key{mtt}{number}{\def\mtt@number{#1}}
\define@key{mtt}{p}{\def\mtt@page{#1}}
\define@key{mtt}{page}{\def\mtt@page{#1}}
\define@key{mtt}{received}{\def\@received{#1}}
\def\mtt#1{\setkeys{mtt}{#1}}
\AtBeginDocument{\@ifundefined{mtt@page}{\relax}{\setcounter{page}{\mtt@page}}}
\def\date#1{\def\@received{#1}}

%  
% . article.cls
\def\maketitle{
  \begingroup
      \newpage
      \global\@topnum\z@   % Prevents figures from going at top of page.
      \@maketitle
    \thispagestyle{frontpage}
  \endgroup
}
\def\@maketitle{%
    \list{}{\listparindent 0pt
        \itemindent 0pt
        \rightmargin 0pt
        \leftmargin 0pt
        \topsep 0pt
        \parsep \z@ \@plus\p@}
    \ifx\@udk\@empty\relax\else\item\normalsize\mtt@UDK\ \@udk\vskip 10mm\fi
    \ifx\@author\@empty\relax\else\item\normalsize
	\@ifundefined{mtt@year}{\relax}{\copyright\mtt@year. }
        \bfseries \@author\vskip 2.5mm
    \fi
    \item\normalsize\bfseries\MakeUppercase\@title
    \endlist
    \ifx\@thanks\@empty\relax\else{\xdef\@thefnmark{}\@footnotetext{\@thanks}}\fi
}

% section      paragraph  article
\renewcommand\section{\@startsection {section}{1}{\parindent}%
                                   {1.5ex \@plus 1ex \@minus .2ex}%
                                   {-1em}%
                                   {\normalfont\normalsize\bfseries}}
%     (\section)   
\def\@seccntformat#1{\csname the#1\endcsname.\ }
%     (\section, \section*)
\let\mtt@ssect=\@ssect
\def\@ssect#1#2#3#4#5{\mtt@ssect{#1}{#2}{#3}{#4}{#5.}}
\let\mtt@sect=\@sect
\def\@sect#1#2#3#4#5#6[#7]#8{\mtt@sect{#1}{#2}{#3}{#4}{#5}{#6}[#7]{#8.}}

%  "/"
\def\mtt@addrlinesep{4mm plus 10mm minus 2mm}
\def\mtt@addrlineskip{0mm plus 10mm minus 4mm}
\def\mtt@addrsep{5mm}
\def\mtt@emailsep{1mm plus 2mm}
\def\makeaddressline{
  \vskip\mtt@addrlinesep
  %    " dd.mm.yyyy"    
  % . 
  \newsavebox{\mtt@recvbox}
  \sbox{\mtt@recvbox}{\ifx\@received\@empty\relax\else\footnotesize\upshape\mtt@RECV\ \@received\fi}
  \newlength{\mtt@recvlen}
  \settowidth{\mtt@recvlen}{\usebox{\mtt@recvbox}}
  \newlength{\mtt@addrlen}
  \setlength{\mtt@addrlen}{\linewidth}
  \addtolength{\mtt@addrlen}{-\mtt@recvlen}
  \addtolength{\mtt@addrlen}{-\mtt@addrsep}
  \par\noindent\parbox[t]{\mtt@addrlen}{
    \footnotesize\slshape\raggedright\@address
    \ifx\@email\@empty\relax\else\vskip\mtt@emailsep\footnotesize\upshape\ttfamily\@email\fi
  }\hskip\mtt@addrsep\usebox{\mtt@recvbox}
  \vskip\mtt@addrlineskip
}

% 
\def\bib{\@ifstar\mtt@bibnoauth\mtt@bibauth}
\def\mtt@bibnoauth{\@ifnextchar[{\mtt@biblabel}{\mtt@bibnolabel}}
\def\mtt@bibauth{\@ifnextchar[{\mtt@biblabelauth}{\mtt@bibnolabelauth}}
\def\mtt@biblabel[#1]{\bibitem{#1}}
\def\mtt@bibnolabel{\item}
\def\mtt@biblabelauth[#1]#2{\bibitem{#1} {\it #2} }
\def\mtt@bibnolabelauth#1{\item {\it #1} }
%  
\def\@biblabel#1{#1. }
\renewenvironment{thebibliography}[1]{
    \vskip 5mm plus 15mm minus 2mm
    \list{\@biblabel{\@arabic\c@enumiv}}{
        \settowidth\labelwidth{\@biblabel{#1}}%
        \leftmargin\labelwidth
        \itemsep 0mm
        \parsep 0mm
        \advance\leftmargin\labelsep
        \@openbib@code
        \usecounter{enumiv}%
        \let\p@enumiv\@empty
        \renewcommand\theenumiv{\@arabic\c@enumiv}}%
    \tolerance1000
    \clubpenalty4000
    \@clubpenalty \clubpenalty
    \widowpenalty4000%
    \sfcode`\.\@m
    \footnotesize
}{\endlist}

\newcommand{\iamm}{\CYRI\cyrn-\cyrt\ \cyrp\cyrr\cyri\cyrk\cyrl. \cyrm\cyra\cyrt\cyre\cyrm\cyra\cyrt\cyri\cyrk\cyri\
    \cyri\ \cyrm\cyre\cyrh\cyra\cyrn\cyri\cyrk\cyri\ \CYRN\CYRA\CYRN\ \CYRU\cyrk\cyrr\cyra\cyri\cyrn\cyrery,
    \CYRD\cyro\cyrn\cyre\cyrc\cyrk}
\def\bs{\bm}
\def\seteq#1{\setcounter{equation}{#1}}
\def\setpic#1{\setcounter{figure}{#1}}

%  Section  ..
\@ifundefined{mtt@oldstyle}{\relax}{
    \typeout{MTT: defining old-style commands}
    \newcommand{\Section}[2][s]{\ifthenelse{\equal{#1}{s}}{\section{#2}}{\section*{#2}}}
    \newcommand{\imail}[1]{\email{#1@iamm.ac.donetsk.ua}}
}

%  
\newlength{\doublecaptionlen}
\newcommand{\doublecaption}[3][.5]{
	\captionsetup{margin=0pt}
	\setlength{\doublecaptionlen}{\linewidth}
	\addtolength{\doublecaptionlen}{-#1\linewidth}
	\parbox{#1\linewidth}{\caption{#2}}\parbox{\doublecaptionlen}{\caption{#3}}
}

%      draft  A4.
%   postscript      tex->dvi->ps->pdf,
% bop-hook     dvips.
\@ifundefined{mtt@pageframe}{\relax}{
    \typeout{MTT: making page frame}
    \AtBeginDvi{\special{! userdict begin /bop-hook {
        10 dict begin gsave
            /m { moveto } bind def
            /l { lineto } bind def
            /i { index } bind def
            /ls { lineto stroke} bind def
            /rls { rlineto stroke} bind def
            /cp { closepath } bind def
            % x0 y0 x1 y0 box -
            /box {
                3 i 3 i m
                3 i 1 i l
                1 i 1 i l
                1 i 3 i l cp
            } def
            %
            % LaTeX       -;
            % (lx,ly)       B5  ps- 
            %  A4
            /lx \strip@pt\Gm@layouthoffset\space def
            /ly \strip@pt\paperheight\space \strip@pt\Gm@layoutvoffset\space sub def
            /lw \strip@pt\Gm@layoutwidth\space def
            /lh \strip@pt\Gm@layoutheight\space def
            /pw \strip@pt\paperwidth\space def
            /ph \strip@pt\paperheight\space def
            /mwb .5 def     %   , pt
            /mwb2 mwb 2 div def
            /mwm 2 def      %   , pt
            /mwm2 mwm 2 div def
            /moff 20 def        %   , pt
            %
            /lx0 lx def
            /ly0 ly def
            /lx1 lx lw add def
            /ly1 ly lh sub def
            %
            mwb setlinewidth
            lx0 mwb2 sub  ly0 mwb2 add 
            lx1 mwb2 add  ly1 mwb2 sub
            box stroke
        end grestore
    } def end}}
}

% vim: ft=tex
